Attribute VB_Name = "mod_Ina219"
Public INA219Registers(50) As Long
Public RegBitLabel(50) As Variant
Public RegLegend(50) As String
Public RegBitTips(50) As Variant
Public Reg_ReadOnly(30) As Boolean
Public PGA_Gain As Double
Public Decmal219_Register(50) As Double
Public Updating_Controls As Boolean
Public sw1
Public Bus_Voltage_Range, ShuntFSR
Public ReadAddress, WriteAddress
Public MarkRegForWrite(50) As Boolean
Public OldReg(50) As Long
Public PowerLSB As Double
Public CurrentLSB As Double
Public Continuous_Read As Boolean

Public MaxPower As Double
Public m_nRealTimeCounter, real_time As Double
'Public disable_graph As Boolean
Public Log_open As Boolean
Public new_path As String
Public old_path As String
Public board_type As Double
Public Europe_Mode As Integer
Public Num_of_Reg As Integer
Public read_once As Integer
Public TestNames(10) As String
Public Function Euro_US_string_fix(ByVal Inval As String) As String
If Len(Inval) = 0 Then Inval = 0


If Europe_Mode = 1 Then
    For iii = 1 To Len(Inval)
    chk_dp = Mid(Inval, iii, 1)
    If chk_dp = "." Then chk_dp = ","
    new_NumFrmt = new_NumFrmt + chk_dp
    Next iii
End If

If Europe_Mode = 0 Then
    For iii = 1 To Len(Inval)
    chk_dp = Mid(Inval, iii, 1)
    If chk_dp = "," Then chk_dp = "."
    new_NumFrmt = new_NumFrmt + chk_dp
    Next iii
End If

Euro_US_string_fix = new_NumFrmt
End Function
Public Function EuroFormat(ByVal Inval As Double, ByVal NumFrmt As String) As String
If Europe_Mode = 1 Then
    For iii = 1 To Len(NumFrmt)
    chk_dp = Mid(NumFrmt, iii, 1)
    If chk_dp = "." Then chk_dp = ","
    new_NumFrmt = new_NumFrmt + chk_dp
    Next iii
End If
EuroFormat = Format(Inval, NumFrmt)
End Function


Public Sub Read_INA_Output_Bits()
'ina219 kill
End Sub
Public Sub Save_Path(path_to_save$)
'
'  This sub saves the prevous path used for file saves / loads
'

On Error GoTo exit_p2:

Open App.Path + "\" + "path_info.txt" For Output As #35
Write #35, path_to_save$
Close #35
Exit Sub

exit_p2:
Close #35
old_path = ""

End Sub
Public Sub Load_Path()
'
'  This sub loads the prevous path used for file saves / loads
'

On Error GoTo exit_p1:

Open App.Path + "\" + "path_info.txt" For Input As #35
Input #35, old_path
Close #35
Exit Sub
exit_p1:
Close #35
old_path = ""
End Sub
Public Sub get_path(path_file$)
Dim i, find_Path$, done_ck
'
'  This sub returns the path only when given the path with the filename (i.e. the filename is striped off)
'
done_ck = 0
find_Path$ = ""
new_path$ = ""
'n_loops = Len(path_file$)
For i = Len(path_file$) To 1 Step -1
    find_Path$ = Left$(path_file$, i)
    If Right$(find_Path$, 1) = "\" And done_ck = 0 Then 'look for left most "\" this is the end of the path
       new_path$ = find_Path$
       done_ck = 1 'ignore other loops
    End If
Next i
End Sub

Public Sub config_chart1()
'117  Scientific Graph showing real-time 3
    
    '** Chart fills 100 points and once 100 points have
    '** been passed, old data is over-written as more
    '** data is passed to chart.
        formMain_INA219.Pesgo1.PlottingMethod = 0 'GPM_POINTSPLUSLINE'was
    formMain_INA219.Pesgo1.ShowAnnotations = True

    formMain_INA219.Pesgo1.Subsets = 1
    formMain_INA219.Pesgo1.Points = 100
    formMain_INA219.Pesgo1.SubsetLabels(0) = "Bus Voltage"
    'formMain_INA219.Pesgo1.SubsetLabels(1) = "Peak Bus Voltage"
     'formMain_INA219.Pesgo1.SubsetColors(1) = &HFF&
   '  formmain_INA219.Pesgo1.GraphAnnotationType(1) = PEGAT_SMALLCROSS
    'formmain_INA219.Pesgo1.GraphAnnotationType(0) = PEPT_SQUARESOLID
    
    '** Set Manual Y scale **'
    formMain_INA219.Pesgo1.ManualScaleControlY = PEMSC_MINMAX
    formMain_INA219.Pesgo1.ManualMinY = 0 'was 1
    formMain_INA219.Pesgo1.ManualMaxY = 32 'was 100
 
    '** Set Manual X scale **'
    formMain_INA219.Pesgo1.ManualScaleControlX = PEMSC_MINMAX
    formMain_INA219.Pesgo1.ManualMinX = 1
    formMain_INA219.Pesgo1.ManualMaxX = 100
 
    '** Show Annotations **'
    formMain_INA219.Pesgo1.ShowAnnotations = True
 
    '** Clear out default data **'
    formMain_INA219.Pesgo1.XData(0, 0) = 0
    formMain_INA219.Pesgo1.XData(0, 1) = 0
    formMain_INA219.Pesgo1.XData(0, 2) = 0
    formMain_INA219.Pesgo1.XData(0, 3) = 0
    formMain_INA219.Pesgo1.YData(0, 0) = 0
    formMain_INA219.Pesgo1.YData(0, 1) = 0
    formMain_INA219.Pesgo1.YData(0, 2) = 0
    formMain_INA219.Pesgo1.YData(0, 3) = 0

    '** Set various properties **'
    formMain_INA219.Pesgo1.MainTitle = "Bus Voltage vs Time"
    formMain_INA219.Pesgo1.SubTitle = ""
    formMain_INA219.Pesgo1.NoRandomPointsToExport = True
    formMain_INA219.Pesgo1.FocalRect = False
    formMain_INA219.Pesgo1.AllowBar = False
    formMain_INA219.Pesgo1.AllowPopup = False
    formMain_INA219.Pesgo1.DeskColor = RGB(192, 192, 192)

    formMain_INA219.Pesgo1.PEactions = 0
    
    formMain_INA219.Pesgo1.XAxisLabel = "Time (sec)"
    formMain_INA219.Pesgo1.YAxisLabel = "Voltage (V)"
     formMain_INA219.Pesgo1.MarkDataPoints = True
    'formmain_INA219.Pesgo1.MinimumPointSize = PEMPS_LARGE
    formMain_INA219.Pesgo1.FontSize = PEFS_LARGE
      
  
End Sub
Public Sub config_chart2()
'117  Scientific Graph showing real-time 3
    
    '** Chart fills 100 points and once 100 points have
    '** been passed, old data is over-written as more
    '** data is passed to chart.
        formMain_INA219.Pesgo2.PlottingMethod = 0 'GPM_POINTSPLUSLINE
    formMain_INA219.Pesgo2.ShowAnnotations = True

    formMain_INA219.Pesgo2.Subsets = 1
    formMain_INA219.Pesgo2.Points = 100
    formMain_INA219.Pesgo2.SubsetLabels(0) = "Shunt Current vs Time"
    'formMain_INA219.Pesgo2.SubsetLabels(1) = "Peak Bus Voltage"
     'formMain_INA219.Pesgo2.SubsetColors(1) = &HFF&
   '  formmain_INA219.Pesgo1.GraphAnnotationType(1) = PEGAT_SMALLCROSS
    'formmain_INA219.Pesgo1.GraphAnnotationType(0) = PEPT_SQUARESOLID
    
    '** Set Manual Y scale **'
    formMain_INA219.Pesgo2.ManualScaleControlY = PEMSC_MINMAX
    formMain_INA219.Pesgo2.ManualMinY = 0 'was 1
    formMain_INA219.Pesgo2.ManualMaxY = EngineeringVal(formMain_INA219.txtMaxI) 'was 100
 
    '** Set Manual X scale **'
    formMain_INA219.Pesgo2.ManualScaleControlX = PEMSC_MINMAX
    formMain_INA219.Pesgo2.ManualMinX = 1
    formMain_INA219.Pesgo2.ManualMaxX = 100
 
    '** Show Annotations **'
    formMain_INA219.Pesgo2.ShowAnnotations = True
 
    '** Clear out default data **'
    formMain_INA219.Pesgo2.XData(0, 0) = 0
    formMain_INA219.Pesgo2.XData(0, 1) = 0
    formMain_INA219.Pesgo2.XData(0, 2) = 0
    formMain_INA219.Pesgo2.XData(0, 3) = 0
    formMain_INA219.Pesgo2.YData(0, 0) = 0
    formMain_INA219.Pesgo2.YData(0, 1) = 0
    formMain_INA219.Pesgo2.YData(0, 2) = 0
    formMain_INA219.Pesgo2.YData(0, 3) = 0

    '** Set various properties **'
    formMain_INA219.Pesgo2.MainTitle = "Shunt Current vs Time"
    formMain_INA219.Pesgo2.SubTitle = ""
    formMain_INA219.Pesgo2.NoRandomPointsToExport = True
    formMain_INA219.Pesgo2.FocalRect = False
    formMain_INA219.Pesgo2.AllowBar = False
    formMain_INA219.Pesgo2.AllowPopup = False
    formMain_INA219.Pesgo2.DeskColor = RGB(192, 192, 192)

    formMain_INA219.Pesgo2.PEactions = 0
    
    formMain_INA219.Pesgo2.XAxisLabel = "Time (sec)"
    formMain_INA219.Pesgo2.YAxisLabel = "Current (A)"
     formMain_INA219.Pesgo2.MarkDataPoints = True
    'formmain_INA219.Pesgo1.MinimumPointSize = PEMPS_LARGE
    formMain_INA219.Pesgo2.FontSize = PEFS_LARGE
      
  
End Sub

Public Sub config_chart3()
'117  Scientific Graph showing real-time 3
    
    '** Chart fills 100 points and once 100 points have
    '** been passed, old data is over-written as more
    '** data is passed to chart.
        formMain_INA219.Pesgo3.PlottingMethod = 0 'GPM_POINTSPLUSLINE
    formMain_INA219.Pesgo3.ShowAnnotations = True

    formMain_INA219.Pesgo3.Subsets = 1
    formMain_INA219.Pesgo3.Points = 100
    formMain_INA219.Pesgo3.SubsetLabels(0) = "Power"
    'formMain_INA219.Pesgo3.SubsetLabels(1) = "Peak Bus Voltage"
     'formMain_INA219.Pesgo3.SubsetColors(1) = &HFF&
   '  formmain_INA219.Pesgo1.GraphAnnotationType(1) = PEGAT_SMALLCROSS
    'formmain_INA219.Pesgo1.GraphAnnotationType(0) = PEPT_SQUARESOLID
    
    '** Set Manual Y scale **'
    formMain_INA219.Pesgo3.ManualScaleControlY = PEMSC_MINMAX
    formMain_INA219.Pesgo3.ManualMinY = 0 'was 1
    formMain_INA219.Pesgo3.ManualMaxY = EngineeringVal(formMain_INA219.txtMaxPower) 'was 100
 
    '** Set Manual X scale **'
    formMain_INA219.Pesgo3.ManualScaleControlX = PEMSC_MINMAX
    formMain_INA219.Pesgo3.ManualMinX = 1
    formMain_INA219.Pesgo3.ManualMaxX = 100
 
    '** Show Annotations **'
    formMain_INA219.Pesgo3.ShowAnnotations = True
 
    '** Clear out default data **'
    formMain_INA219.Pesgo3.XData(0, 0) = 0
    formMain_INA219.Pesgo3.XData(0, 1) = 0
    formMain_INA219.Pesgo3.XData(0, 2) = 0
    formMain_INA219.Pesgo3.XData(0, 3) = 0
    formMain_INA219.Pesgo3.YData(0, 0) = 0
    formMain_INA219.Pesgo3.YData(0, 1) = 0
    formMain_INA219.Pesgo3.YData(0, 2) = 0
    formMain_INA219.Pesgo3.YData(0, 3) = 0

    '** Set various properties **'
    formMain_INA219.Pesgo3.MainTitle = "Power vs Time"
    formMain_INA219.Pesgo3.SubTitle = ""
    formMain_INA219.Pesgo3.NoRandomPointsToExport = True
    formMain_INA219.Pesgo3.FocalRect = False
    formMain_INA219.Pesgo3.AllowBar = False
    formMain_INA219.Pesgo3.AllowPopup = False
    formMain_INA219.Pesgo3.DeskColor = RGB(192, 192, 192)

    formMain_INA219.Pesgo3.PEactions = 0
    
    formMain_INA219.Pesgo3.XAxisLabel = "Time (sec)"
    formMain_INA219.Pesgo3.YAxisLabel = "Power (W)"
     formMain_INA219.Pesgo3.MarkDataPoints = True
    formMain_INA219.Pesgo3.FontSize = PEFS_LARGE
      
  
End Sub


Public Function Shift_Right(word_to_shift, no_positions)
Shift_Right = Int(word_to_shift / (2 ^ no_positions))
End Function
Public Function Shift_Left(word_to_shift, no_positions)
Shift_Left = Int(word_to_shift * (2 ^ no_positions))

End Function

Public Sub UpdateRegisterDisplay_Normal(Optional UpdateFlag As Boolean = True)
'
'updated for ina219
'
Num_of_Reg = 5
    Dim i As Integer    ' loop index
  With formMain_INA219.gridReg
    If .TextMatrix(1, 0) <> "00h" Then 'if running for the first time
                                    ' fill out the info columns
        .TextMatrix(1, 0) = "00h"
        .TextMatrix(1, 1) = " Config"
        .TextMatrix(2, 0) = "01h"
        .TextMatrix(2, 1) = " Shunt Voltage" '" Status"
        .TextMatrix(3, 0) = "02h"
        .TextMatrix(3, 1) = " Bus Voltage" '" SMBus Alert Mask / Enable Control"
        .TextMatrix(4, 0) = "03h"
        .TextMatrix(4, 1) = " Power" '" Shunt Voltage"
        .TextMatrix(5, 0) = "04h"
        .TextMatrix(5, 1) = " Current / PGA" '" Bus Voltage"
        .TextMatrix(6, 0) = "05h"
        .TextMatrix(6, 1) = " Full Scale Cal" '" Power"
   End If
    'If UpdateFlag And (formMain_INA219.chkAutoSum = 1) Then
                'if checksum update is allowed
        'Call CalcCheckSumRegisters
    'End If
    
    ' old feb 29
    'For i = 0 To Num_of_Reg
   '     If OldReg(i) <> INA219Registers(i) Then
    '        MarkRegForWrite(i) = True
    '    End If
    'Next i
    
    
    'display *** for changed reg
        For i = 0 To Num_of_Reg
        If OldReg(i) <> INA219Registers(i) Then
            MarkRegForWrite(i) = True
        End If
        If MarkRegForWrite(i) = True Then
            .TextMatrix(i + 1, 1) = " *** " + TestNames(i + 1) + " *** "
        End If
        Next i

    
    
    
    
    For i = 0 To Num_of_Reg
         OldReg(i) = INA219Registers(i)
    Next i
    
    For i = 0 To Num_of_Reg
        .TextMatrix(i + 1, 2) = "0x" & RegVal2Str(INA219Registers(i), 1, False)
        .TextMatrix(i + 1, 3) = "0x" & RegVal2Str(INA219Registers(i), 0, False)
    Next i
    For i = 0 To Num_of_Reg
        Select Case i
        Case 0, 5, 6, 7 'skip -- no analog equ
        Case Else
        Call UpdateDecimal(i)
        .TextMatrix(i + 1, 4) = Decmal219_Register(i)
        End Select
    Next i
  End With
  Call formMain_INA219.ShowRegDetails       ' update those
  Call Update_Controls 'update controls based on reg values

 Updating_Controls = True

 formMain_INA219.txtShunt(0).Text = Euro_US_string_fix(Decmal219_Register(1)) 'fixed for ina219
 formMain_INA219.txtShunt(1).Text = Euro_US_string_fix(Decmal219_Register(1)) 'fixed for ina219
 formMain_INA219.txtShunt(5).Text = Euro_US_string_fix(INA219Registers(1))  'fixed for ina219
 formMain_INA219.txtVbus(0).Text = Euro_US_string_fix(Decmal219_Register(2)) 'fixed for ina219
 formMain_INA219.txtVbus(1).Text = Euro_US_string_fix(Decmal219_Register(2)) 'fixed for ina219
 formMain_INA219.txtPower(0).Text = Euro_US_string_fix(Decmal219_Register(3)) 'fixed for ina219
 formMain_INA219.cmd_I_shunt.Text = Euro_US_string_fix(Decmal219_Register(4)) 'fixed for ina219
 

 formMain_INA219.txtVbus(6) = (INA219Registers(&H2&))  'fixed for ina219
 formMain_INA219.txtPower(3) = (INA219Registers(&H3&)) 'fixed for ina219
 formMain_INA219.txtCurrent2 = (INA219Registers(&H4&))  'fixed for ina219
 formMain_INA219.txtFSC = (INA219Registers(&H5&))  'fixed for ina219

 
 

 Updating_Controls = False


End Sub
Public Sub UpdateRegisterDisplay(Optional UpdateFlag As Boolean = True)

If formMain_INA219.mnuEngineeringMode.Checked = False Then
    Call UpdateRegisterDisplay_Normal(UpdateFlag)
Else
    Call UpdateRegisterDisplay_eng(UpdateFlag)
End If

End Sub

Public Sub UpdateRegisterDisplay_eng(Optional UpdateFlag As Boolean = True)
Num_of_Reg = 7


    Dim i As Integer    ' loop index
  With formMain_INA219.gridReg
     If .TextMatrix(8, 1) <> " Trim data read " Then   'if running for the first time
        .TextMatrix(1, 0) = "00h"
        .TextMatrix(1, 1) = " Config"
        .TextMatrix(2, 0) = "01h"
        .TextMatrix(2, 1) = " Shunt Voltage" '" Status"
        .TextMatrix(3, 0) = "02h"
        .TextMatrix(3, 1) = " Bus Voltage" '" SMBus Alert Mask / Enable Control"
        .TextMatrix(4, 0) = "03h"
        .TextMatrix(4, 1) = " Power" '" Shunt Voltage"
        .TextMatrix(5, 0) = "04h"
        .TextMatrix(5, 1) = " Current / PGA" '" Bus Voltage"
        .TextMatrix(6, 0) = "05h"
        .TextMatrix(6, 1) = " Full Scale Cal" '" Power"
        .TextMatrix(7, 0) = "06h"
        .TextMatrix(7, 1) = " Trim control/test " '" Power"
        .TextMatrix(8, 0) = "07h"
        .TextMatrix(8, 1) = " Trim data read " '" Power"
    End If
    
  '  For i = 0 To Num_of_Reg
   '     If OldReg(i) <> INA219Registers(i) Then
   '         MarkRegForWrite(i) = True
   '     End If
  '  Next i
    
       'display *** for changed reg
        For i = 0 To Num_of_Reg
        If OldReg(i) <> INA219Registers(i) Then
            MarkRegForWrite(i) = True
        End If
        If MarkRegForWrite(i) = True Then
            .TextMatrix(i + 1, 1) = " *** " + TestNames(i + 1) + " *** "
        End If
        Next i

    
    
    
    For i = 0 To Num_of_Reg
         OldReg(i) = INA219Registers(i)
    Next i
    
    
    For i = 0 To Num_of_Reg
        .TextMatrix(i + 1, 2) = "0x" & RegVal2Str(INA219Registers(i), 1, False)
        .TextMatrix(i + 1, 3) = "0x" & RegVal2Str(INA219Registers(i), 0, False)
    Next i
    For i = 0 To Num_of_Reg
        Select Case i
        Case 0, 5, 6, 7 'skip -- no analog equ
        Case Else
        Call UpdateDecimal(i)
        .TextMatrix(i + 1, 4) = Decmal219_Register(i)
        End Select
    Next i
  End With
     Call formMain_INA219.ShowRegDetails       ' update those
     Call Update_Controls 'update controls based on reg values
 Updating_Controls = True

  formMain_INA219.txtShunt(0).Text = Euro_US_string_fix(Decmal219_Register(1)) 'CHANGED FOR INA219
  formMain_INA219.txtShunt(1).Text = Euro_US_string_fix(Decmal219_Register(1)) 'CHANGED FOR INA219
  formMain_INA219.txtShunt(5).Text = Euro_US_string_fix(INA219Registers(1))  'fixed for ina219
  formMain_INA219.txtVbus(0).Text = Euro_US_string_fix(Decmal219_Register(2)) 'CHANGED FOR INA219
  formMain_INA219.txtVbus(1).Text = Euro_US_string_fix(Decmal219_Register(2)) 'CHANGED FOR INA219
  formMain_INA219.txtPower(0).Text = Euro_US_string_fix(Decmal219_Register(3)) 'CHANGED FOR INA219
  formMain_INA219.cmd_I_shunt.Text = Euro_US_string_fix(Decmal219_Register(1)) 'CHANGED FOR INA219
 
 formMain_INA219.txtFSC = (INA219Registers(&H5&))   'CHANGED FOR INA219
 formMain_INA219.txtCurrent2 = (INA219Registers(&H4&))  'CHANGED FOR INA219
 formMain_INA219.txtVbus(6) = (INA219Registers(&H2&)) 'CHANGED FOR INA219
 formMain_INA219.txtPower(3) = (INA219Registers(&H3&)) 'CHANGED FOR INA219
 
Updating_Controls = False

End Sub

Public Sub Read_INA219()
If formMain_INA219.mnuEngineeringMode.Checked = False Then
    Call Read_INA219_Normal
Else
    Call Read_INA219_ENG
End If

With formMain_INA219.gridReg
    For i = 0 To Num_of_Reg
        .TextMatrix(i + 1, 1) = TestNames(i + 1) 'reset reg edited indicater
    Next i
End With


End Sub
       
Public Sub Read_INA219_Normal()
'Call random_reg
For REG = 0 To Num_of_Reg
    Call RunMnemonicCommand("I2C CH1 S " + Hex(WriteAddress) + " ACKS " + Hex(REG) + " ACKS P") 'set pointer
    If ACK_Responce(0) <> 0 Or ACK_Responce(1) <> 0 Then
        formMain_INA219.txtDutNotAck.Visible = True
        formMain_INA219.txtDutNotAck.Text = "INA219 Did Not Acknowledge!"
    Else
        formMain_INA219.txtDutNotAck.Visible = False
    End If
    Call RunMnemonicCommand("I2C CH1 S " + Hex(ReadAddress) + " ACKS R ACKM R ACKM P")
    INA219Registers(REG) = ReadData(0) * &H100& + ReadData(1)
    If ACK_Responce(0) <> 0 Then
        formMain_INA219.txtDutNotAck.Visible = True
        formMain_INA219.txtDutNotAck.Text = "INA219 Did Not Acknowledge!"
    Else
        formMain_INA219.txtDutNotAck.Visible = False
    End If
Next REG

For REG = 0 To Num_of_Reg
    Call UpdateDecimal(REG)
Next REG
Call Read_INA_Output_Bits

Call UpdateRegisterDisplay

End Sub
Public Sub DoGraph()
   ' Call Read_INA219
   ' Call Read_INA_Output_Bits
   ' DoEvents

 
    
    'm_nRealTimeCounter = 0

    
    
    '** Update new data at current index  **'
     formMain_INA219.Pesgo1.YData(0, m_nRealTimeCounter) = Decmal219_Register(2) 'Decmal219_Register(4)'bus v
     formMain_INA219.Pesgo1.XData(0, m_nRealTimeCounter) = m_nRealTimeCounter
    
     formMain_INA219.Pesgo1.VertLineAnnotation(0) = m_nRealTimeCounter
     formMain_INA219.Pesgo1.VertLineAnnotationType(0) = PELT_MEDIUMSOLID
     formMain_INA219.Pesgo1.VertLineAnnotationColor(0) = QBColor(12)

   
    '** Update image and force paint **'
     formMain_INA219.Pesgo1.PEnarg1 = 0
     formMain_INA219.Pesgo1.PEnarg2 = 0
     formMain_INA219.Pesgo1.PEactions = 0  '// Calls PEresetimage
    
    
    
    
    
    '** Update new data at current index  **'
     formMain_INA219.Pesgo2.YData(0, m_nRealTimeCounter) = Decmal219_Register(4) 'Decmal219_Register(6)'current
     formMain_INA219.Pesgo2.XData(0, m_nRealTimeCounter) = m_nRealTimeCounter
    
     formMain_INA219.Pesgo2.VertLineAnnotation(0) = m_nRealTimeCounter
     formMain_INA219.Pesgo2.VertLineAnnotationType(0) = PELT_MEDIUMSOLID
     formMain_INA219.Pesgo2.VertLineAnnotationColor(0) = QBColor(12)

    '** Update image and force paint **'
     formMain_INA219.Pesgo2.PEnarg1 = 0
     formMain_INA219.Pesgo2.PEnarg2 = 0
     formMain_INA219.Pesgo2.PEactions = 0
 
 
 
 
     '** Update new data at current index  **'
     formMain_INA219.Pesgo3.YData(0, m_nRealTimeCounter) = Decmal219_Register(3) 'Decmal219_Register(5) 'power
     formMain_INA219.Pesgo3.XData(0, m_nRealTimeCounter) = m_nRealTimeCounter
    
     formMain_INA219.Pesgo3.VertLineAnnotation(0) = m_nRealTimeCounter
     formMain_INA219.Pesgo3.VertLineAnnotationType(0) = PELT_MEDIUMSOLID
     formMain_INA219.Pesgo3.VertLineAnnotationColor(0) = QBColor(12)

    '** Update image and force paint **'
     formMain_INA219.Pesgo3.PEnarg1 = 0
     formMain_INA219.Pesgo3.PEnarg2 = 0
     formMain_INA219.Pesgo3.PEactions = 0

 
 '** Increment counter **'
     m_nRealTimeCounter = Timer - real_time
 
 
 
        If m_nRealTimeCounter >= 100 Then
           m_nRealTimeCounter = 0
           real_time = Timer
        End If

End Sub

Public Sub Read_INA219_ENG()
'Call random_reg
For REG = 0 To Num_of_Reg
    Call RunMnemonicCommand("I2C CH1 S " + Hex(WriteAddress) + " ACKS " + Hex(REG) + " ACKS P") 'set pointer
    Call RunMnemonicCommand("I2C CH1 S " + Hex(ReadAddress) + " ACKS R ACKM R ACKM P")
    INA219Registers(REG) = ReadData(0) * &H100& + ReadData(1)
Next REG

For REG = 0 To Num_of_Reg
    Call UpdateDecimal(REG)
Next REG

Call UpdateRegisterDisplay

End Sub
       

Public Function RegVal2Str(Inval As Long, Frmt As Integer, TwosComp As Boolean) As String
        ' inVal is the input number
        ' Frmt is the output format: 0 - binary, 1 - hex (4symbols), 2 - decimal
        ' TwosComp - 2's compliment flag, True/False
    Dim AdjVal As Long
    If TwosComp And (Inval < 0) Then    'processing 2's compliment value
        AdjVal = Inval + 65536
    Else
        AdjVal = Inval
    End If
    If (AdjVal < 0) Or (AdjVal > 65535) Then ' return empty str if input is out of limits
        RegVal2Str = ""
        Exit Function
    End If
    Select Case Frmt
    Case 0  ' binary
        RegVal2Str = Display16Bit(AdjVal)
    Case 1  ' hex
        RegVal2Str = Hex(AdjVal)    ' changed from Format(Hex(AdjVal), "0000")
        Do While Len(RegVal2Str) < 4
                ' add leading zeros
            RegVal2Str = "0" & RegVal2Str
        Loop
    Case 2 ' decimal (note: no 2's compliment in this case)
        RegVal2Str = Format(CStr(Inval), "#####0")
    End Select
End Function
Public Function binary2decmal(binaryVal As String) As Double
Dim dig_bin, dig_pow
binary2decmal = 0
dig_pow = 0
dig_bin = 0
For i = 0 To Len(binaryVal) - 1
    dig_bin = Mid(binaryVal, Len(binaryVal) - i, 1)
    If dig_bin = "1" Then
        binary2decmal = binary2decmal + 2 ^ (dig_pow)
    End If
    If dig_bin = "1" Or dig_bin = "0" Then
        dig_pow = dig_pow + 1
    End If
Next i
End Function

Public Function Display16Bit(Inval As Long) As String
    Display16Bit = DisplayBinary(Inval)
    If Len(Display16Bit) > 16 Then
        Display16Bit = Right(Display16Bit, 16)
    Else
        While Len(Display16Bit) < 16
'            If ((Len(Display16Bit) Mod 4) = 0) Then Display16Bit = "_" & Display16Bit
            Display16Bit = "0" & Display16Bit
        Wend
    End If
    Display16Bit = Mid(Display16Bit, 1, 4) & "_" _
                 & Mid(Display16Bit, 5, 4) & "_" _
                 & Mid(Display16Bit, 9, 4) & "_" _
                 & Mid(Display16Bit, 13, 4)
End Function
Public Function DisplayBinary(Inval As Long) As String
    If Inval = 0 Then
        DisplayBinary = 0
    Else
        DisplayBinary = DisplayBinary(Fix(Inval / 2#)) & Format(Inval Mod 2, "0")
    End If
End Function
Public Sub SetRegLegend()
  Dim i As Integer
  RegLegend(0) = "RST - Device Reset.  Resets all registers to devault values (Normal=0, Reset=1)" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'" & vbCrLf & _
    "BRNG: Bus Voltage Range(0=16V, 1=32V)" & vbCrLf & _
    "PG1, PG0: Programable Gain (00=1, 01=div2, 10=div4, 11=div8)" & vbCrLf & _
    "B_ADC4,B_ADC3,B_ADC2,B_ADC2: Bus ADC Resolution/Averaging" & vbCrLf & _
    "S_ADC4,S_ADC3,S_ADC2,S_ADC1: Shunt ADC Resolution/Averaging" & vbCrLf & _
    "MODE3,MODE2,MODE1: Controls various modes of operation (e.g. trigered versus Continuous readings).  See data sheet for details."
 RegLegend(1) = "WOV: Warning Bus Overvoltage" & vbCrLf & _
    "WUV:   Warning Bus Undervoltage" & vbCrLf & _
    "WP:    Warning Power" & vbCrLf & _
    "WS+:   Warning Shunt +Voltage" & vbCrLf & _
    "WS-:   Warning Shunt -Voltage" & vbCrLf & _
    "OLOV:  Overlimit Bus Overvoltage" & vbCrLf & _
    "OLUV:  Overlimit Bus Undervoltage" & vbCrLf & _
    "OLP:   Overlimit Power" & vbCrLf & _
    "CNVR:  Conversion Ready." & vbCrLf & _
    "CRIT+: Critical Shunt +Voltage" & vbCrLf & _
    "CRIT-: Critical Shunt -Voltage" & vbCrLf & _
    "SMBA:  SMBus Alert (clears only on reading Status Reg or by disabling SMBus Alert function)." & vbCrLf & _
    "OVF:   Math overflow (indicates that current and power may be meaningless)" & vbCrLf & _
    "RFB:  Reserved Factory Bit.  Set to RFB = '0'"
  RegLegend(2) = "M_WOV:  " & vbCrLf & _
    "M_WUV:  " & vbCrLf & _
    "MWP:  " & vbCrLf & _
    "MWS+:  " & vbCrLf & _
    "MWS-:  " & vbCrLf & _
    "M OLOV:  " & vbCrLf & _
    "M OLUV:  " & vbCrLf & _
    "M_OLP:  " & vbCrLf & _
    "M_CRIT+:  " & vbCrLf & _
    "M_CRIT-:  " & vbCrLf & _
    "M_CNVR:  " & vbCrLf & _
    "RFB:   " & vbCrLf & _
    "SMA_EN:  SMBus Alert Enable" & vbCrLf & _
    "CR_EN:  Critical Alarm Output Enable" & vbCrLf & _
    "OL_EN:  Overlimit Alarm Output Enable" & vbCrLf & _
    "WRN_EN:  Warning Alarm Output Enable" & vbCrLf
 RegLegend(3) = "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "RFB: Reserved Factory Bit: Set to zero for proper operation" & vbCrLf & _
    "EXS - Linearization Adjust & Excitation Voltage (VEXC) Gain Select (Range1 or Range2)" & vbCrLf & _
    "0=Range 1 (-0.166VFB < Linearization DAC Range < +0.166VFB, VEXC Gain=0.83VREF)" & vbCrLf & _
    "1=Range 2 (-0.124VFB < Linearization DAC Range < +0.124VFB, VEXC Gain=0.52VREF)" & vbCrLf & _
    "EXEN - VEXC Enable: 1= Enable VEXC; 0=Disable VEXC" & vbCrLf & _
    "RS - Internal VREF Select: 0=4.096V; 1=2.5V" & vbCrLf & _
    "REN - Enable/Disable Internal VREF (Disable for External VREF - Connect External VREF to REFIN/REFOUT pin):" & vbCrLf & _
    "   0=External Reference (Disable Internal Reference); 1=Internal Reference (Enable Internal Reference)" & vbCrLf & _
    "LD[7:0] - Linearization DAC setting, 7 bit + sign"
  RegLegend(4) = "BD15: " & vbCrLf & _
    "BD12: " & vbCrLf & _
    "BD11: " & vbCrLf & _
    "BD10: " & vbCrLf & _
    "BD9: " & vbCrLf & _
    "BD8: " & vbCrLf & _
    "BD7: " & vbCrLf & _
    "BD6: " & vbCrLf & _
    "BD5: " & vbCrLf & _
    "BD4: " & vbCrLf & _
    "BD3: " & vbCrLf & _
    "BD2: " & vbCrLf & _
    "BD1: " & vbCrLf & _
    "RFB: Factory reserved" & vbCrLf & _
    "RFB: Factory reserved" & vbCrLf & _
    "RFB: Factory reserved" & vbCrLf
  RegLegend(5) = "PD15: " & vbCrLf & _
    "PD14: " & vbCrLf & _
    "PD13: " & vbCrLf & _
    "PD12: " & vbCrLf & _
    "PD11: " & vbCrLf & _
    "PD10: " & vbCrLf & _
    "PD9: " & vbCrLf & _
    "PD8: " & vbCrLf & _
    "PD7: " & vbCrLf & _
    "PD6: " & vbCrLf & _
    "PD5: " & vbCrLf & _
    "PD4: " & vbCrLf & _
    "PD3: " & vbCrLf & _
    "PD2: " & vbCrLf & _
    "PD1: " & vbCrLf & _
    "PD0: " & vbCrLf

  RegLegend(6) = "CSign: " & vbCrLf & _
    "CD14: " & vbCrLf & _
    "CD13: " & vbCrLf & _
    "CD12: " & vbCrLf & _
    "CD11: " & vbCrLf & _
    "CD10: " & vbCrLf & _
    "CD9: " & vbCrLf & _
    "CD8: " & vbCrLf & _
    "CD7: " & vbCrLf & _
    "CD6: " & vbCrLf & _
    "CD5: " & vbCrLf & _
    "CD4: " & vbCrLf & _
    "CD3: " & vbCrLf & _
    "CD2: " & vbCrLf & _
    "CD1: " & vbCrLf & _
    "CD0: " & vbCrLf

  RegLegend(7) = "SPP Sign: " & vbCrLf & _
    "SPP14: " & vbCrLf & _
    "SPP13: " & vbCrLf & _
    "SPP12: " & vbCrLf & _
    "SPP11: " & vbCrLf & _
    "SPP10: " & vbCrLf & _
    "SPP9: " & vbCrLf & _
    "SPP8: " & vbCrLf & _
    "SPP7: " & vbCrLf & _
    "SPP6: " & vbCrLf & _
    "SPP5: " & vbCrLf & _
    "SPP4: " & vbCrLf & _
    "SPP3: " & vbCrLf & _
    "SPP2: " & vbCrLf & _
    "SPP1: " & vbCrLf & _
    "SPP0: " & vbCrLf
    


 
' now setting the individual bit Labels
    RegBitLabel(0) = Array("RST", "D14", "BRNG", "PG1", "PG0", "B_ADC4", "B_ADC3", "B_ADC2", "B_ADC1", "S_ADC4", "S_ADC3", "S_ADC2", "S_ADC1", "MODE3", "MODE2", "MODE1")
    RegBitLabel(1) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
    RegBitLabel(2) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
    RegBitLabel(3) = Array("PD15", "PD14", "PD13", "PD12", "PD11", "PD10", "PD9", "PD8", "PD7", "PD6", "PD5", "PD4", "PD3", "PD2", "PD1", "PD0")
    RegBitLabel(4) = Array("CSign", "CD14", "CD13", "CD12", "CD11", "CD10", "CD9", "CD8", "CD7", "CD6", "CD5", "CD4", "CD3", "CD2", "CD1", "CD0")
    RegBitLabel(5) = Array("FS15", "FS14", "FS13", "FS12", "FS11", "FS10", "FS9", "FS8", "FS7", "FS6", "FS5", "FS4", "FS3", "FS2", "FS0", "FS0")
    RegBitLabel(6) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
    RegBitLabel(7) = Array("D15", "D14", "D13", "D12", "D11", "D10", "D9", "D8", "D7", "D6", "D5", "D4", "D3", "D2", "D1", "D0")
    
    
 Reg_ReadOnly(0) = False
 Reg_ReadOnly(1) = True
 Reg_ReadOnly(2) = True
 Reg_ReadOnly(3) = True
 Reg_ReadOnly(4) = True
 Reg_ReadOnly(5) = False
 Reg_ReadOnly(6) = False
 Reg_ReadOnly(7) = True
End Sub


Public Sub WriteAllRegisters()

    For i = 0 To Num_of_Reg
        If MarkRegForWrite(i) = True Then
            Call WriteReg(i)
        End If
    Next i
    
    
   For i = 0 To Num_of_Reg
            MarkRegForWrite(i) = False
    Next i
    
    
With formMain_INA219.gridReg
    For i = 0 To Num_of_Reg
        .TextMatrix(i + 1, 1) = TestNames(i + 1) 'reset reg edited indicater
    Next i
End With


End Sub
Public Sub UpdateDisplay(RegNumber)

'
'  Update RegLegend acording to register settings
'
If RegNumber = 0 Then
    pg1_pg0 = ((&H1800) And (INA219Registers(RegNumber))) / (2 ^ 11)
    If pg1_pg0 = 0 Then
        PGA_Gain = 1
        ShuntFSR = 0.04
    ElseIf pg1_pg0 = 1 Then
        PGA_Gain = 2
        ShuntFSR = 0.08
    ElseIf pg1_pg0 = 2 Then
        PGA_Gain = 4
        ShuntFSR = 0.16
    ElseIf pg1_pg0 = 3 Then
        PGA_Gain = 8
        ShuntFSR = 0.32
    End If
    '
    '  Update reg 3
    '
    RegLegend(3) = ""
    For i = 0 To 15
        If PGA_Gain = 1 And i < 15 Then
            RegLegend(3) = "SD" + Str(i) + ": Shunt Voltage bit" + vbCrLf + RegLegend(3)
            RegBitLabel(3)(15 - i) = "SD" + Str(i)
        ElseIf PGA_Gain = 2 And i < 14 Then
            RegLegend(3) = "SD" + Str(i) + ": Shunt Voltage bit" + vbCrLf + RegLegend(3)
            RegBitLabel(3)(15 - i) = "SD" + Str(i)
        ElseIf PGA_Gain = 4 And i < 13 Then
            RegLegend(3) = "SD" + Str(i) + ": Shunt Voltage bit" + vbCrLf + RegLegend(3)
            RegBitLabel(3)(15 - i) = "SD" + Str(i)
       ElseIf PGA_Gain = 8 And i < 12 Then
            RegLegend(3) = "SD" + Str(i) + ": Shunt Voltage bit" + vbCrLf + RegLegend(3)
            RegBitLabel(3)(15 - i) = "SD" + Str(i)
        Else
            RegLegend(3) = "Sign bit" + vbCrLf + RegLegend(3)
            RegBitLabel(3)(15 - i) = "Sign bit"
       End If
            
    Next i
    '
    '  Update reg 4
    '
    BRNG = ((&H2000) And (INA219Registers(RegNumber))) / (2 ^ 13)
    If BRNG = 0 Then
        Bus_Voltage_Range = 16
    ElseIf BRNG = 1 Then
        Bus_Voltage_Range = 32
    End If
    RegLegend(4) = ""
    For i = 0 To 15
       If Bus_Voltage_Range = 16 And i = 15 Then
            RegLegend(4) = "RFB:  Reserved Factory Bit" + vbCrLf + RegLegend(4)
            RegBitLabel(4)(15 - i) = "RFB"
       ElseIf i < 2 Then
            RegLegend(4) = "RFB:  Reserved Factory Bit" + vbCrLf + RegLegend(4)
            RegBitLabel(4)(15 - i) = "RFB"
       Else
            RegLegend(4) = "BD" + Str(i - 2) + ": Bus Voltage bit" + vbCrLf + RegLegend(4)
            RegBitLabel(4)(15 - i) = "BD" + Str(i - 2)
       End If
    Next i
    
End If

End Sub
Public Sub UpdateDecimal(RegNumber)
Select Case RegNumber
Case 1 'was 3, 7, 8, &HC&, &HD&
    If (INA219Registers(RegNumber) And (&H8000&)) = 0 Then
         Decmal219_Register(RegNumber) = INA219Registers(RegNumber)
    Else
        Decmal219_Register(RegNumber) = -(&H8000& - (INA219Registers(RegNumber) And &H7FFF&))
    End If
    Decmal219_Register(RegNumber) = Decmal219_Register(RegNumber) * 0.00001
Case 2 'was 4, 9, &HA&, &HF&, &H10&, &H12&, &H13&
    Decmal219_Register(RegNumber) = Int(INA219Registers(RegNumber) / (2 ^ 3)) 'shift right 3
    Decmal219_Register(RegNumber) = Decmal219_Register(RegNumber) * 0.004
Case 3 'was 5, &HB&, &HE&, &H11&
    Decmal219_Register(RegNumber) = INA219Registers(RegNumber) * PowerLSB
Case 4 'was 6
    If (INA219Registers(RegNumber) And (&H8000&)) = 0 Then
        Decmal219_Register(RegNumber) = INA219Registers(RegNumber)
    Else
        Decmal219_Register(RegNumber) = -(&H8000& - (INA219Registers(RegNumber) And &H7FFF&))
    End If
    Decmal219_Register(RegNumber) = Decmal219_Register(RegNumber) * CurrentLSB
End Select

End Sub

Public Sub Integer_Register_to_Decimal(RegNumber, decmal_reg)
Select Case RegNumber
Case &HC&, &HD& 'SHUNT VOLTAGE
    signed_int = Int(decmal_reg / 0.00001)
    If Abs(signed_int) < &H7FFF& Then
        If signed_int >= 0 Then
            INA219Registers(RegNumber) = signed_int
        Else
            INA219Registers(RegNumber) = &H10000 - Abs(signed_int)
        End If
    Else
        MsgBox "Analog value out of range"
    End If
Case &HE&, &H11& 'Power Warning, Power OverLimit
    If PowerLSB <> 0 Then
    signed_int = Int(decmal_reg / PowerLSB)
    If Abs(signed_int) < &H7FFF Then
        INA219Registers(RegNumber) = signed_int
    Else
        MsgBox "Analog value out of range" + vbCrLf + "Max Power = " + Str(MaxPower)
    End If
    End If
Case &HF&, &H10&, &H12&, &H13& 'Bus voltage
    signed_int = Int(decmal_reg / 0.004)
    signed_int = signed_int * (2 ^ 3)
    If Abs(signed_int) < &HFFFF& Then
        INA219Registers(RegNumber) = signed_int
    Else
        MsgBox "Analog value out of range"
    End If
Case &H14&   'crit dac+
    signed_int = Int(decmal_reg / 0.001)
    signed_int = signed_int * (2 ^ 8)
    If Abs(signed_int) < &HFFFF& Then
        INA219Registers(RegNumber) = signed_int
    Else
        MsgBox "Analog value out of range"
    End If
Case &H15&  'crit dac-
    If decmal_reg <= 0 And decmal_reg >= -0.255 Then
    signed_int = Int(-decmal_reg / 0.001)
    signed_int = signed_int * (2 ^ 8)
    INA219Registers(RegNumber) = signed_int
    Else
         MsgBox "Analog value out of range" + vbCrLf + "-0.255 < Critical Dac- <= 0"
    End If
End Select

End Sub

Public Sub Update_Controls()
Updating_Controls = True

    pg1_pg0 = ((&H1800) And (INA219Registers(0))) / (2 ^ 11)
    If pg1_pg0 = 0 Then
        PGA_Gain = 1
        ShuntFSR = 0.04
    ElseIf pg1_pg0 = 1 Then
        PGA_Gain = 2
        ShuntFSR = 0.08
    ElseIf pg1_pg0 = 2 Then
        PGA_Gain = 4
        ShuntFSR = 0.16
    ElseIf pg1_pg0 = 3 Then
        PGA_Gain = 8
        ShuntFSR = 0.32
    End If
    formMain_INA219.txtMaxShunt = Euro_US_string_fix(ShuntFSR)
    formMain_INA219.cmbShuntGain.ListIndex = pg1_pg0
    
   ' formMain_INA219.cmbWarnPol.ListIndex = Shift_Right(INA219Registers(&HF&) And &H2&, 1)  ' warning pol
  '  formMain_INA219.cmbOverlimPol.ListIndex = Shift_Right(INA219Registers(&H12&) And &H2&, 1)  ' overlimit pol
  '  formMain_INA219.cmbCritFaultPol.ListIndex = Shift_Right(INA219Registers(&H14&) And (2 ^ 4), 4) ' crit pol
  '  formMain_INA219.cmbCritCompHyst.ListIndex = Shift_Right(INA219Registers(&H14&) And &HE&, 1) ' crit hyst
    
    BRNG = ((&H2000&) And (INA219Registers(0))) / (2 ^ 13)
    If BRNG = 0 Then
        Bus_Voltage_Range = 16
    ElseIf BRNG = 1 Then
        Bus_Voltage_Range = 32
    End If
    formMain_INA219.cmbBusGain.ListIndex = BRNG
    formMain_INA219.txtMaxBus = Euro_US_string_fix(Bus_Voltage_Range)

    SADC = ((&H78&) And (INA219Registers(0))) / (2 ^ 3)
    If SADC <= 7 Then
        formMain_INA219.cmbShuntResolution.ListIndex = (SADC) And (&H3&)
    ElseIf SADC > 7 Then
        formMain_INA219.cmbShuntResolution.ListIndex = SADC - 4
    End If
    

    BADC = ((&H780&) And (INA219Registers(0))) / (2 ^ 7)
    If BADC <= 7 Then
        formMain_INA219.cmbBusResolution.ListIndex = (BADC) And (&H3&)
    ElseIf BADC > 7 Then
        formMain_INA219.cmbBusResolution.ListIndex = BADC - 4
    End If

    mode = ((&H7&) And (INA219Registers(0)))
    formMain_INA219.cmbAdsMode.ListIndex = mode

    'WD = ((&HF&) And (INA219Registers(&H15&)))
    'formMain_INA219.cmbProgDelay.ListIndex = WD
    
    'For i = 5 To 15
   '        formMain_INA219.txtMask(i).Text = Right(Str(Shift_Right(INA219Registers(2) And (2 ^ i), i)), 1)

   ' Next i
    
    'formMain_INA219.chkWarningEnable.value = Shift_Right(INA219Registers(2) And (2 ^ 0), 0)
    'formMain_INA219.chkOverlimitEnable.value = Shift_Right(INA219Registers(2) And (2 ^ 1), 1)
    'formMain_INA219.chkEnableCriticalFault.value = Shift_Right(INA219Registers(2) And (2 ^ 2), 2)
    'formMain_INA219.chkSMB_AlertEnable.value = Shift_Right(INA219Registers(2) And (2 ^ 3), 3)
    'formMain_INA219.chkWarningLatch = INA219Registers(&HF&) And &H1&
    'formMain_INA219.chkOverlimitLatch = INA219Registers(&H12&) And &H1&


Updating_Controls = False
End Sub
Public Sub Read_Controls()
If Updating_Controls = True Then Exit Sub



    '
    ' a1, a0
    '
    
    a0 = formMain_INA219.cmbA0.ListIndex
    a1 = formMain_INA219.cmbA1.ListIndex
    
    
    address = 4 * a1 + a0 + &H40&
    ReadAddress = address * 2 + 1
    WriteAddress = address * 2
    formMain_INA219.txtAddress = Hex$(address)
    '
    ' WD - Warning delay
    '

   'WD = formMain_INA219.cmbProgDelay.ListIndex
   'INA219Registers(&H15&) = (INA219Registers(&H15&) And &HFFF0&) Or (WD)
    '
    ' pg1_pg0 - PGA shunt voltage only
    '
    pg1_pg0 = (formMain_INA219.cmbShuntGain.ListIndex) * (2 ^ 11)
    INA219Registers(0) = (INA219Registers(0) And &HE7FF&) Or pg1_pg0
    '
    '
   SADC = formMain_INA219.cmbShuntResolution.ListIndex
   If SADC <= 3 Then
        SADC = (SADC) * (2 ^ 3)
   Else
        SADC = (SADC + 4) * (2 ^ 3)
   End If
   INA219Registers(0) = (INA219Registers(0) And &HFF87&) Or (SADC)
    '
    '
   BADC = formMain_INA219.cmbBusResolution.ListIndex
   If BADC <= 3 Then
        BADC = (BADC) * (2 ^ 7)
   Else
        BADC = (BADC + 4) * (2 ^ 7)
   End If
   INA219Registers(0) = (INA219Registers(0) And &HF87F&) Or (BADC)
    '
    '
        mode = formMain_INA219.cmbAdsMode.ListIndex
    INA219Registers(0) = (INA219Registers(0) And &HFFF8&) Or (mode)
    '
    ' BRNG - bus range
    '
   BRNG = (formMain_INA219.cmbBusGain.ListIndex) * (2 ^ 13)
   INA219Registers(0) = (INA219Registers(0) And &HDFFF&) Or (BRNG)



'INA219Registers(&H14&) = (INA219Registers(&H14&) And &HFFF1&) Or (Shift_Left(formMain_INA219.cmbCritCompHyst.ListIndex, 1)) ' crit hyst

Call UpdateRegisterDisplay

End Sub

Public Sub random_reg()
For i = 0 To &H16
INA219Registers(i) = Int(Rnd(1) * &HFFFF&)
'MsgBox Hex$(INA219Registers(RegNumber))
Next i
End Sub
Public Sub WriteReg(RegNumber)
REG_MSB = Int(INA219Registers(RegNumber) / &H100&)
REG_LSB = INA219Registers(RegNumber) And &HFF&
Call RunMnemonicCommand("I2C CH1 S " + Hex(WriteAddress) + " ACKS " + Hex(RegNumber) + " ACKS " + Hex(REG_MSB) + " ACKS " + Hex(REG_LSB) + " ACKS " + " P") 'set pointer

Call UpdateDisplay(RegNumber)
End Sub


